// You must provide a vertex and fragment shader to OpenGL.
// Here we supply about the simplest possible vertex shader.

// An ADD comment will be used to indicate variables and code added
// to subsequent shaders to increase functionality.
// The CHANGE comment will show changes made to demo shader code from 
// previous version.

// You have to specify the version of the shader language used.
// GLSL 1.50 is sufficient for our purposes.
#version 150 core

// Minimally, we need to receive the vertex position as x, y, z coordinates.
// The relationship between this local variable and the data are
// set in the OpenGL init(...) method provided by the implementing Java class.

// The vertex coordinates: x, y, z.
in vec3 position;

void main()
{
    // Here we will later apply lots of transformations, but for now,
    // we simple pass the coordinates on for further processing by OpenGL in 
    // homogeneous coordinate form.
    // Homogeneous coordinate form is (x, y, z, alpha), alpha=1.0=opaque
    gl_Position = vec4(position, 1.0);
}
